from collections import deque


counter = 0
def new_name(name="_T"):
    global counter
    counter += 1
    return f"{name}_{counter}"


def integer_variable(*args):
    x = args[0]
    if len(args) ==  3:
        lb = args[1]
        ub = args[2]
        if lb == ub:
            print(_c("int", x, lb))
        elif lb > ub:
            print(_c("int", x, ub, lb))
        else:
            print(_c("int", x, lb, ub))
    elif len(args) == 2:
        print(_c("int", x, args[1]))
    else:
        raise TypeError(f"addSolverStat() takes exactly 2 or 3 arguments ({len(args)} given)")


def Add(*args):
    return _c("+", *args)


def Sub(x, *xs):
    return _c("-", x, *xs)


def Eq(x, y):
    return _c("=", x, y)


def Neq(x, y):
    return _c("!=", x, y)


def Ge(x, y):
    return _c(">=", x, y)


def Gt(x, y):
    return _c(">", x, y)


def Le(x, y):
    return _c("<=", x, y)


def Lt(x, y):
    return _c("<", x, y)


def Not(arg):
    return _c("not", arg)


def And(*args):
    return _c("and", *args)


def Or(*args):
    return _c("or", *args)


def Imp(x, y):
    return _c("=>", x, y)


def Iff(x, y):
    return _c("iff", x, y)


def _v(name, *args):
    indices = [str(x) for x in args]
    return name + "_" + "_".join(indices)


def _c(*args):
    elems = [str(x) for x in args]
    return "(" + " ".join(elems) + ")"


def atleast_1(xs):
    print("; atleast_1 " + " ".join(xs))
    ors = [_c(">", x, 0) for x in xs]
    print(_c("or", " ".join(ors)))


def atmost_1(xs):
    print("; atmost_1 " + " ".join(xs))
    for i in range(0, len(xs)):
        for j in range(i+1, len(xs)):
            print(_c("<=", _c("+", xs[i], xs[j]), 1))


def exact_1(xs):
    atleast_1(xs)
    atmost_1(xs)


def atleast_k(k, xs):
    print(_c(">=", _c("+", " ".join(xs)), k))


def atmost_k(k, xs):
    print(_c("<=", _c("+", " ".join(xs)), k))


def exact_k(k, xs):
    print(_c("=", _c("+", " ".join(xs)), k))


def alldiff(xs):
    n = len(xs)
    if n == 1:
        return
    print(_c("alldifferent", " ".join(xs)))


bb_label = 0
def Ge_bb(r, *xs):  # r => x_1 + ... + x_n
    print(f"; {r} >= {Add(*xs)}")
    n = len(xs)
    if n <= 0:
        return
    elif n == 1:
        print(Ge(r, *xs))
        return
    global bb_label
    bb_label += 1
    count = {}
    for k in reversed(range(n, 2*n)):
        count[k] = 1

    for k in reversed(range(1, n)):
        count[k] = count[2*k] + count[2*k+1]

    for k in range(2, n):
        b = _v(f"_b{bb_label}", k)
        integer_variable(b, 0, min(count[k], r))

    for k in range(2, n):
        b = []
        for c in [2*k, 2*k+1]:
            if n <= c < 2*n:
                b.append(xs[c-n])
            else:
                b.append(_v(f"_b{bb_label}", c))
        b.append(_v(f"_b{bb_label}", k))
        print(Le(Add(b[0], b[1]), b[2]))

    b = []
    for c in [2, 3]:
        if n <= c < 2*n:
            b.append(xs[c-n])
        else:
            b.append(_v(f"_b{bb_label}", c))
    print(Le(Add(b[0], b[1]), r))


def Ge_simple_bb(r, *xs):  # r >= x1 ... xn
    que = deque(xs)
    while len(que) != 1:
        v1 = que.popleft()
        v2 = que.popleft()
        que.append(Add(v1, v2))
    x = que.popleft()
    return Ge(r, x)


def Le_simple_bb(r, *xs):  # r <= x1 ... xn
    que = deque(xs)
    while len(que) != 1:
        v1 = que.popleft()
        v2 = que.popleft()
        que.append(Add(v1, v2))
    x = que.popleft()
    return Le(r, x)